/*******************************************************************/
/*
  COPYRIGHT: (c) 1992@2000 by SP&AR&C HOLLAND by GNU Public Licence 
  FILE : config.h
  DESCRIPTION : types and configuration in behalf of sorting program
  PROJECT : SSORT
  AUTHOR : A vd Horst
  LANGUAGE : Turbo C++ (3.0)
  CREATED : 920904 AH
  LAST CHANGE : 950206 AH total clean up, configuration
  LAST CHANGE : 921109 AH TRACE introduced
  LAST CHANGE : 920917 max/min introduced
                                                                   */
/*******************************************************************/

// "TRACE << " puts a string on the trace channel, unless DEBUG
#ifdef DEBUG
   #define TRACE cerr
#else
// Use /##/ instead of //, because TC preprocessor already interprets //
   #define TRACE /##/
   #define assert(a)
#endif

// "OPT" marks the start of optimizing lines, compiled only if OPTIMIZE
#ifdef OPTIMIZE
   #define OPT
#else
  #define OPT /##/
#endif

// The names of the intermediate files are put here, for easy change.
#define SCRATCH1 "1$$$$$$$.$$$"
#define SCRATCH2 "2$$$$$$$.$$$"

// This file contains all the configuration items you may want to change.

// WARNING: we are using only unsigned char's throughout of SSORT,
// apart of the specification of filenames
typedef unsigned char CHAR;

typedef signed char *STRING;
// These macros in lower case, because it really are standard types.
// Delete if your compiler has ``bool'' built in.
typedef int bool;
#define true (1)
#define false (0)

// The buffer size normally used for a text buffer
const int normalbufsize = 32000;

// If you regret the name space pollution,
// put the following constants in a class Config or some such.
// The buffer size used in the conversion to a text file in SSORT.CPP
const int streamcopybufsize = 32000;

// The length of the sort and merge heaps in SSORT.CPP
const int heapsize =20;

// Number of mergepoints in MERGEP.CPP:
//    maximum number of sorted parts into which files are split
const int fifosize=10000;

// Number of comparators that may be installed in SCOMPARE.CPP.
const int installedcomparatorssize=50;

// Number of fields that can be handled at most in SEARCH.CPP.
const int fieldsinrecordsize = 100;

// ############## defines #####################

#define PRIVATE static
#define FORWARD /* nothing */

/* Not a valid index */
#define NONE (-1)

// Strousup would allow this. Fix up of terrible syntax.
#define STRING_EQUAL(a,b) (!strcmp(a,b))

// Replace these by templates if your compiler can handle it
#define min(a,b)    (((a) < (b)) ? (a) : (b))
#define max(a,b)    (((a) > (b)) ? (a) : (b))

