/*******************************************************************/
/*
  COPYRIGHT: (c) 1992@2000 by SP&AR&C HOLLAND by GNU Public Licence 
  FILE : lexcrea.c
  DESCRIPTION : generates a inverse lexicographical sorted table
  PROJECT : SSORT
  AUTHOR : A vd Horst
  LANGUAGE : Turbo C++ (3.0)
  CREATED : 920912 AH
  LAST CHANGE : 950206 AH total clean up, configuration
  LAST CHANGE : 921111 AH comment clean up
  LAST CHANGE :
                                                                   */
/*******************************************************************/

/*****************************************************************************/
/*                                                                           */
/*   The table generated should have the following properties: It is an      */
/*   include file to initialise a table of characters. All relevant          */
/*   characters are present.                                                 */
/*   table[c1]<=table[c2] <==> c1 lexicographically lower than c2            */
/*   This is accomplished by reading in the characters in sorted order. The  */
/*   weight attached to a character is equal to the ordinal number in that   */
/*   order.                                                                  */
/*                                                                           */
/*****************************************************************************/

#include <iostream.h>
#include <stdlib.h>
#include "config.h"

void main()
{
   unsigned char buf[30];
   int i=0;
   int table[256];

   for (i=0;i<256;i++)
      table[i]=0;

   i = 0;

//   The following does not work:
//   while ( cin>>buf )
//   It refuses the lines starting with ^L ^H and ^I

   while ( cin.read( buf,2 ) )
   {
      TRACE << (int)buf[0]<< ' '<<(int)buf[1]<< '\n';
      table[buf[0]] = i++;
      if ( i>256 )
        cerr<<"Too many characters in input";
   }

   cout <<
"/******************************************\n"
"  COPYRIGHT: 1992@1995 by SP&AR&C HOLLAND\n"
"  FILE : lextab.h\n"
"  DESCRIPTION : table to look up lexicographic weight of a char\n"
"*/\n"
"\n"
"{\n";

   for (i=0;i<256;i++)
   {
      cout <<table[i];
      if ( 255!=i ) cout << ',';
      if ( 15==i%16 ) cout << '\n';
   }
   cout<<"};\n";
   exit(0);
}
