/*******************************************************************/
/*
  COPYRIGHT: (c) 1992@2000 by SP&AR&C HOLLAND by GNU Public Licence 
  FILE : lib.cpp
  DESCRIPTION : utilities (implementation) in behalf of SSORT
  PROJECT : SSORT
  AUTHOR : A vd Horst
  LANGUAGE : Turbo C++ (3.0)
  CREATED : 920906 AH
  LAST CHANGE : 9502106 AH changfilesize added
  LAST CHANGE : 950206 AH total clean up, configuration
  LAST CHANGE : 921213 AH ``amen'' manipulator introduced
  LAST CHANGE : 921112 AH comment clean up
  LAST CHANGE :
                                                                   */
/*******************************************************************/


#include <string.h>
#include <assert.h>
#include <iostream.h>
#include <iomanip.h>
#include <io.h>
#include <fcntl.h>
#include <stdlib.h>

#include "config.h"

extern char usage[];

/*****************************************************************************/
/*                                                                           */
/*   Allocates a string `s' on the heap, returns the result.                 */
/*                                                                           */
/*****************************************************************************/

STRING heapc( STRING s )
{
   STRING temp = new char[strlen(s)+1];
   assert(temp);
   strcpy(temp,s);
   return temp;
}

/*****************************************************************************/
/*                                                                           */
/*   ``amen'' is an output manipulator that flushes the output stream,       */
/*   gives the usage message and exits the program with failure.             */
/*   In fact it should only used with the error channel, and its return      */
/*   value will never be used.                                               */
/*   The ``usage'' string is assumed elsewhere probably in the main program  */
/*                                                                           */
/*****************************************************************************/

ostream& amen( ostream& outchan )
{
   outchan << usage << endl;
   exit(EXIT_FAILURE);
   return outchan;
}


/*****************************************************************************/
/*                                                                           */
/*  ``changefilesize'' changes the length of the file with name ``name'' by  */
/*  the amount ``correction'', be it negative or positive. The bytes that    */
/*  remain after the correction, have not changed.                           */
/*                                                                           */
/*****************************************************************************/

void changefilesize( const char *name, int correction )
{
   TRACE<<"Changing file size of "<<name<<" by "<<correction<<'\n';
   int handle = open( name, O_BINARY|O_RDWR );
   assert( handle != -1 );
   long size = filelength(handle);
   assert( size != -1L );
   int result = chsize( handle, size+correction );
   assert ( result != -1 );
   result = close( handle );
   assert ( result != -1 );
}
