/*******************************************************************/
/*
  COPYRIGHT: (c) 1992@2000 by SP&AR&C HOLLAND by GNU Public Licence 
  FILE : ssortlib.cpp
  DESCRIPTION : general purpose routines
  PROJECT : SSORT
  AUTHOR : A vd Horst
  LANGUAGE : Turbo C++ (3.0)
  CREATED : 941102 AH
  LAST CHANGE : 950206 AH total clean up, configuration
  LAST CHANGE : 941204 AH streams clean up
  LAST CHANGE : 941102 AH Made a class
                                                                   */
/*******************************************************************/


#include <dos.h>
#include <process.h>
#include <fstream.h>
#include <ctype.h>

#include "config.h"
#include "lib.h"
#include "Ssortlib.h"


/*****************************************************************************/
/*                                                                           */
/*  ``MSDOSweight'' returns a pointer to the collate table from MSDOS. ("Get */
/*  Collate-Sequence Table). This table contains the order of characters     */
/*  currently installed dependant of the current country and so called "code */
/*  Page".                                                                   */
/*                                                                           */
/*  ''escapedchar'' returns the next character at ``pc'' and also increments */
/*  it, in order to skip the consumed characters. It handles all single      */
/*  characters denoted by an escape sequence starting with '\\' as described */
/*  in the documentation.                                                    */
/*                                                                           */
/*****************************************************************************/


CHAR far *Ssortlib::MSDOSweight( void )
{
   // Fill in the registers for the msdos call
   REGS regs;
   regs.x.bx=0xFFFF;     // Specify: current code page
   regs.x.cx=5;          // Minimum prescribed buffer lenght
   regs.x.dx=0xFFFF;     // Specifiy: current country
   regs.x.ax=0x6506;     // DOS: Get Collate-Sequence Table

   SREGS sregs;

   // Where the result is filled in
   struct {
      unsigned char dummy[2];   // Address to be passed skips one byte
      unsigned char far *table;
   } result;

   // Dirty trick to split a far pointer into a segment and an offset
   // Compiler dependant!
   // INT 21H is going to put the result at ES:DI
   union {
         void far * pointer;
         unsigned int seg[2];
   }  aux;
   aux.pointer=&(result.dummy[1]);
   regs.x.di=aux.seg[0];   // Offset
   sregs.es=aux.seg[1];    // Segment

   // Call DOS. Compiler dependant!
   intdosx( &regs, &regs, &sregs );

   if ( 6 != result.dummy[1] )
      cerr<<" geen goede return code\n"<<amen;
   int length = *(int far *)result.table;
   if ( 256 != length )
      cerr<<" wat moeten we nu weer\n"<<amen;
   unsigned char far *weight;
   weight = result.table +2;
   return weight;
}
